diff --git a/libexec/comsat/comsat.c b/libexec/comsat/comsat.c
index 07ecb9365a..85b8fff3f0 100644
--- a/libexec/comsat/comsat.c
+++ b/libexec/comsat/comsat.c
@@ -1,4 +1,6 @@
-/*
+/*-
+ * SPDX-License-Identifier: BSD-3-Clause
+ *
  * Copyright (c) 1980, 1993
  *	The Regents of the University of California.  All rights reserved.
  *
@@ -27,7 +29,7 @@
  * SUCH DAMAGE.
  *
  * @(#)comsat.c	8.1 (Berkeley) 6/4/93
- * $FreeBSD: src/libexec/comsat/comsat.c,v 1.17 2005/02/14 17:42:56 stefanf Exp $
+ * $FreeBSD: head/libexec/comsat/comsat.c 326025 2017-11-20 19:49:47Z pfg $
  */
 
 #include <sys/param.h>
@@ -52,26 +54,22 @@
 #include <sysexits.h>
 #include <syslog.h>
 #include <unistd.h>
-#include <utmp.h>
+#include <utmpx.h>
 
-int	debug = 0;
+static int	debug = 0;
 #define	dsyslog	if (debug) syslog
 
 #define MAXIDLE	120
 
-char	hostname[MAXHOSTNAMELEN];
-struct	utmp *utmp = NULL;
-time_t	lastmsgtime;
-int	nutmp, uf;
+static char	hostname[MAXHOSTNAMELEN];
 
-void jkfprintf (FILE *, const char *, const char *, off_t);
-void mailfor (char *);
-void notify (struct utmp *, char *, off_t, int);
-void onalrm (int);
-void reapchildren (int);
+static void	jkfprintf(FILE *, char[], char[], off_t);
+static void	mailfor(char *);
+static void	notify(struct utmpx *, char[], off_t, int);
+static void	reapchildren(int);
 
 int
-main(int argc __unused, char **argv __unused)
+main(int argc __unused, char *argv[] __unused)
 {
 	struct sockaddr_in from;
 	socklen_t fromlen;
@@ -88,15 +86,7 @@ main(int argc __unused, char **argv __unused)
 		recv(0, msgbuf, sizeof(msgbuf) - 1, 0);
 		exit(1);
 	}
-	if ((uf = open(_PATH_UTMP, O_RDONLY, 0)) < 0) {
-		syslog(LOG_ERR, "open: %s: %m", _PATH_UTMP);
-		recv(0, msgbuf, sizeof(msgbuf) - 1, 0);
-		exit(1);
-	}
-	time(&lastmsgtime);
 	gethostname(hostname, sizeof(hostname));
-	onalrm(0);
-	signal(SIGALRM, onalrm);
 	signal(SIGTTOU, SIG_IGN);
 	signal(SIGCHLD, reapchildren);
 	for (;;) {
@@ -107,57 +97,28 @@ main(int argc __unused, char **argv __unused)
 			errno = 0;
 			continue;
 		}
-		if (!nutmp)		/* no one has logged in yet */
-			continue;
-		sigblock(sigmask(SIGALRM));
 		msgbuf[cc] = '\0';
-		time(&lastmsgtime);
 		mailfor(msgbuf);
 		sigsetmask(0L);
 	}
 }
 
-void
+static void
 reapchildren(int signo __unused)
 {
 	while (wait3(NULL, WNOHANG, NULL) > 0);
 }
 
-void
-onalrm(int signo __unused)
-{
-	static u_int utmpsize;		/* last malloced size for utmp */
-	static time_t utmpmtime;	/* last modification time for utmp */
-	struct stat statbf;
-
-	if (time(NULL) - lastmsgtime >= MAXIDLE)
-		exit(EX_OK);
-	alarm((u_int)15);
-	fstat(uf, &statbf);
-	if (statbf.st_mtime > utmpmtime) {
-		utmpmtime = statbf.st_mtime;
-		if (statbf.st_size > utmpsize) {
-			utmpsize = statbf.st_size + 10 * sizeof(struct utmp);
-			if ((utmp = realloc(utmp, utmpsize)) == NULL) {
-				syslog(LOG_ERR, "realloc: %m");
-				exit(1);
-			}
-		}
-		lseek(uf, (off_t)0, SEEK_SET);
-		nutmp = read(uf, utmp, (size_t)statbf.st_size)/sizeof(struct utmp);
-	}
-}
-
-void
+static void
 mailfor(char *name)
 {
-	struct utmp *utp = &utmp[nutmp];
+	struct utmpx *utp;
 	char *cp;
 	char *file;
 	off_t offset;
 	int folder;
-	char buf[sizeof(_PATH_MAILDIR) + sizeof(utmp[0].ut_name) + 1];
-	char buf2[sizeof(_PATH_MAILDIR) + sizeof(utmp[0].ut_name) + 1];
+	char buf[sizeof(_PATH_MAILDIR) + sizeof(utp->ut_user) + 1];
+	char buf2[sizeof(_PATH_MAILDIR) + sizeof(utp->ut_user) + 1];
 
 	if (!(cp = strchr(name, '@')))
 		return;
@@ -167,62 +128,71 @@ mailfor(char *name)
 		file = name;
 	else
 		file = cp + 1;
-	sprintf(buf, "%s/%.*s", _PATH_MAILDIR, (int)sizeof(utmp[0].ut_name),
+	sprintf(buf, "%s/%.*s", _PATH_MAILDIR, (int)sizeof(utp->ut_user),
 	    name);
 	if (*file != '/') {
 		sprintf(buf2, "%s/%.*s", _PATH_MAILDIR,
-		    (int)sizeof(utmp[0].ut_name), file);
+		    (int)sizeof(utp->ut_user), file);
 		file = buf2;
 	}
 	folder = strcmp(buf, file);
-	while (--utp >= utmp)
-		if (!strncmp(utp->ut_name, name, sizeof(utmp[0].ut_name)))
+	setutxent();
+	while ((utp = getutxent()) != NULL)
+		if (utp->ut_type == USER_PROCESS && !strcmp(utp->ut_user, name))
 			notify(utp, file, offset, folder);
+	endutxent();
 }
 
 static const char *cr;
 
-void
-notify(struct utmp *utp, char *file, off_t offset, int folder)
+static void
+notify(struct utmpx *utp, char file[], off_t offset, int folder)
 {
 	FILE *tp;
 	struct stat stb;
 	struct termios tio;
-	char tty[20], name[sizeof(utmp[0].ut_name) + 1];
+	char tty[20];
+	const char *s = utp->ut_line;
 
-	snprintf(tty, sizeof(tty), "%s%.*s",
-	    _PATH_DEV, (int)sizeof(utp->ut_line), utp->ut_line);
-	if (strchr(tty + sizeof(_PATH_DEV) - 1, '/')) {
+	if (strncmp(s, "pts/", 4) == 0)
+		s += 4;
+	if (strchr(s, '/')) {
 		/* A slash is an attempt to break security... */
-		syslog(LOG_AUTH | LOG_NOTICE, "'/' in \"%s\"", tty);
+		syslog(LOG_AUTH | LOG_NOTICE, "Unexpected `/' in `%s'",
+		    utp->ut_line);
 		return;
 	}
-	if (stat(tty, &stb) || !(stb.st_mode & (S_IXUSR | S_IXGRP))) {
-		dsyslog(LOG_DEBUG, "%s: wrong mode on %s", utp->ut_name, tty);
+	snprintf(tty, sizeof(tty), "%s%.*s",
+	    _PATH_DEV, (int)sizeof(utp->ut_line), utp->ut_line);
+	if (stat(tty, &stb) == -1 || !(stb.st_mode & (S_IXUSR | S_IXGRP))) {
+		dsyslog(LOG_DEBUG, "%s: wrong mode on %s", utp->ut_user, tty);
 		return;
 	}
-	dsyslog(LOG_DEBUG, "notify %s on %s\n", utp->ut_name, tty);
-	if (fork())
+	dsyslog(LOG_DEBUG, "notify %s on %s", utp->ut_user, tty);
+	switch (fork()) {
+	case -1:
+		syslog(LOG_NOTICE, "fork failed (%m)");
 		return;
-	signal(SIGALRM, SIG_DFL);
-	alarm((u_int)30);
+	case 0:
+		break;
+	default:
+		return;
+	}
 	if ((tp = fopen(tty, "w")) == NULL) {
 		dsyslog(LOG_ERR, "%s: %s", tty, strerror(errno));
 		_exit(1);
 	}
 	tcgetattr(fileno(tp), &tio);
 	cr = ((tio.c_oflag & (OPOST|ONLCR)) == (OPOST|ONLCR)) ?  "\n" : "\n\r";
-	strncpy(name, utp->ut_name, sizeof(name) - 1);
-	name[sizeof(name) - 1] = '\0';
 	switch (stb.st_mode & (S_IXUSR | S_IXGRP)) {
 	case S_IXUSR:
 	case (S_IXUSR | S_IXGRP):
 		fprintf(tp, 
 		    "%s\007New mail for %s@%.*s\007 has arrived%s%s%s:%s----%s",
-		    cr, name, (int)sizeof(hostname), hostname,
+		    cr, utp->ut_user, (int)sizeof(hostname), hostname,
 		    folder ? cr : "", folder ? "to " : "", folder ? file : "",
 		    cr, cr);
-		jkfprintf(tp, name, file, offset);
+		jkfprintf(tp, utp->ut_user, file, offset);
 		break;
 	case S_IXGRP:
 		fprintf(tp, "\007");
@@ -237,8 +207,8 @@ notify(struct utmp *utp, char *file, off_t offset, int folder)
 	_exit(EX_OK);
 }
 
-void
-jkfprintf(FILE *tp, const char *user, const char *file, off_t offset)
+static void
+jkfprintf(FILE *tp, char user[], char file[], off_t offset)
 {
 	unsigned char *cp, ch;
 	FILE *fi;
@@ -253,7 +223,7 @@ jkfprintf(FILE *tp, const char *user, const char *file, off_t offset)
 	if ((fi = fopen(file, "r")) == NULL)
 		return;
 
-	fseeko(fi, offset, SEEK_SET);
+	fseeko(fi, offset, SEEK_CUR);
 	/*
 	 * Print the first 7 lines or 560 characters of the new mail
 	 * (whichever comes first).  Skip header crap other than
diff --git a/libexec/ftpd/logwtmp.c b/libexec/ftpd/logwtmp.c
index dd306fbd13..406d9a107a 100644
--- a/libexec/ftpd/logwtmp.c
+++ b/libexec/ftpd/logwtmp.c
@@ -1,4 +1,6 @@
-/*
+/*-
+ * SPDX-License-Identifier: BSD-3-Clause
+ *
  * Copyright (c) 1988, 1993
  *	The Regents of the University of California.  All rights reserved.
  *
@@ -27,7 +29,7 @@
  * SUCH DAMAGE.
  *
  * @(#)logwtmp.c	8.1 (Berkeley) 6/4/93
- * $FreeBSD: src/libexec/ftpd/logwtmp.c,v 1.9.2.2 2002/08/08 12:24:54 yar Exp $
+ * $FreeBSD: head/libexec/ftpd/logwtmp.c 326025 2017-11-20 19:49:47Z pfg $
  */
 
 #include <sys/types.h>
@@ -36,44 +38,36 @@
 #include <arpa/inet.h>
 #include <sys/socket.h>
 
-#include <fcntl.h>
-#include <time.h>
-#include <netdb.h>
-#include <utmp.h>
-#include <unistd.h>
+#include <libutil.h>
 #include <stdio.h>
 #include <string.h>
-#include <libutil.h>
+#include <unistd.h>
+#include <utmpx.h>
 #include "extern.h"
 
-static int fd = -1;
-
-/*
- * Modified version of logwtmp that holds wtmp file open
- * after first call, for use with ftp (which may chroot
- * after login, but before logout).
- */
 void
-ftpd_logwtmp(char *line, char *name, struct sockaddr *addr)
+ftpd_logwtmp(char *id, char *user, struct sockaddr *addr)
 {
-	struct utmp ut;
-	struct stat buf;
-	char host[UT_HOSTSIZE];
+	struct utmpx ut;
 
-	if (addr == NULL)
-		host[0] = '\0';
-	else
-		realhostname_sa(host, sizeof(host), addr, addr->sa_len);
+	memset(&ut, 0, sizeof(ut));
 
-	if (fd < 0 && (fd = open(_PATH_WTMP, O_WRONLY|O_APPEND, 0)) < 0)
-		return;
-	if (fstat(fd, &buf) == 0) {
-		(void)strncpy(ut.ut_line, line, sizeof(ut.ut_line));
-		(void)strncpy(ut.ut_name, name, sizeof(ut.ut_name));
-		(void)strncpy(ut.ut_host, host, sizeof(ut.ut_host));
-		(void)time(&ut.ut_time);
-		if (write(fd, &ut, sizeof(struct utmp)) !=
-		    sizeof(struct utmp))
-			(void)ftruncate(fd, buf.st_size);
+	if (user != NULL) {
+		/* Log in. */
+		ut.ut_type = USER_PROCESS;
+		(void)strncpy(ut.ut_user, user, sizeof(ut.ut_user));
+		if (addr != NULL)
+			realhostname_sa(ut.ut_host, sizeof(ut.ut_host),
+			    addr, addr->sa_len);
+	} else {
+		/* Log out. */
+		ut.ut_type = DEAD_PROCESS;
 	}
+
+	ut.ut_pid = getpid();
+	gettimeofday(&ut.ut_tv, NULL);
+	(void)strncpy(ut.ut_id, id, sizeof(ut.ut_id));
+	(void)strncpy(ut.ut_line, "ftpd", sizeof(ut.ut_line));
+
+	pututxline(&ut);
 }
diff --git a/lib/libutil/login.c b/libexec/rpc.rusersd/extern.h
similarity index 67%
rename from lib/libutil/login.c
rename to libexec/rpc.rusersd/extern.h
index 3b65e637f8..3186af03bc 100644
--- a/lib/libutil/login.c
+++ b/libexec/rpc.rusersd/extern.h
@@ -1,6 +1,8 @@
 /*-
- * Copyright (c) 1988, 1993
- *	The Regents of the University of California.  All rights reserved.
+ * SPDX-License-Identifier: BSD-3-Clause
+ *
+ * Copyright (c) 1993, John Brezak
+ * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
@@ -26,32 +28,9 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- * @(#)login.c	8.1 (Berkeley) 6/4/93
- * $FreeBSD: src/lib/libutil/login.c,v 1.6 1999/08/28 00:05:45 peter Exp $
+ * $FreeBSD: head/libexec/rpc.rusersd/extern.h 326025 2017-11-20 19:49:47Z pfg $
  */
 
-#include <sys/types.h>
-
-#include <fcntl.h>
-#include <stdlib.h>
-#include <unistd.h>
-#include <utmp.h>
-#include <libutil.h>
-
-void
-login(struct utmp *ut)
-{
-	int fd;
-	int tty;
+extern int from_inetd;
 
-	tty = ttyslot();
-	if (tty > 0 && (fd = open(_PATH_UTMP, O_WRONLY|O_CREAT, 0644)) >= 0) {
-		(void)lseek(fd, (off_t)(tty * sizeof(struct utmp)), L_SET);
-		(void)write(fd, ut, sizeof(struct utmp));
-		(void)close(fd);
-	}
-	if ((fd = open(_PATH_WTMP, O_WRONLY|O_APPEND, 0)) >= 0) {
-		(void)write(fd, ut, sizeof(struct utmp));
-		(void)close(fd);
-	}
-}
+void rusers_service(struct svc_req *, SVCXPRT *);
diff --git a/libexec/rpc.rusersd/rusers_proc.c b/libexec/rpc.rusersd/rusers_proc.c
index bbce3785d6..adcea32c16 100644
--- a/libexec/rpc.rusersd/rusers_proc.c
+++ b/libexec/rpc.rusersd/rusers_proc.c
@@ -1,4 +1,6 @@
 /*-
+ * SPDX-License-Identifier: BSD-3-Clause
+ *
  * Copyright (c) 1993, John Brezak
  * All rights reserved.
  *
@@ -26,7 +28,7 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- * $FreeBSD: src/libexec/rpc.rusersd/rusers_proc.c,v 1.10 1999/08/28 00:09:56 peter Exp $
+ * $FreeBSD: head/libexec/rpc.rusersd/rusers_proc.c 326025 2017-11-20 19:49:47Z pfg $
  */
 
 #ifdef DEBUG
@@ -38,61 +40,31 @@
 #include <sys/param.h>
 #include <sys/stat.h>
 #include <syslog.h>
-#include <utmp.h>
+#include <utmpx.h>
 #ifdef XIDLE
 #include <setjmp.h>
 #include <X11/Xlib.h>
 #include <X11/extensions/xidle.h>
 #endif
-#define utmp rutmp
 #include <rpcsvc/rnusers.h>
-#undef utmp
-
-#define	IGNOREUSER	"sleeper"
 
-#ifdef OSF
-#define _PATH_UTMP UTMP_FILE
-#endif
-
-#ifndef _PATH_UTMP
-#define _PATH_UTMP "/etc/utmp"
-#endif
+#include "extern.h"
 
 #ifndef _PATH_DEV
 #define _PATH_DEV "/dev"
 #endif
 
-#ifndef UT_LINESIZE
-#define UT_LINESIZE sizeof(((struct utmp *)0)->ut_line)
-#endif
-#ifndef UT_NAMESIZE
-#define UT_NAMESIZE sizeof(((struct utmp *)0)->ut_name)
-#endif
-#ifndef UT_HOSTSIZE
-#define UT_HOSTSIZE sizeof(((struct utmp *)0)->ut_host)
-#endif
-
-typedef char ut_line_t[UT_LINESIZE+1];
-typedef char ut_name_t[UT_NAMESIZE+1];
-typedef char ut_host_t[UT_HOSTSIZE+1];
-
-utmpidle utmp_idle[MAXUSERS];
-rutmp old_utmp[MAXUSERS];
-ut_line_t line[MAXUSERS];
-ut_name_t name[MAXUSERS];
-ut_host_t host[MAXUSERS];
-
-extern int from_inetd;
-
-FILE *ufp;
+static utmpidle utmp_idle[MAXUSERS];
+static utmp old_utmp[MAXUSERS];
+static struct utmpx utmp_list[MAXUSERS];
 
 #ifdef XIDLE
-Display *dpy;
+static Display *dpy;
 
 static jmp_buf openAbort;
 
 static void
-abortOpen ()
+abortOpen(void)
 {
     longjmp (openAbort, 1);
 }
@@ -114,14 +86,12 @@ XqueryIdle(char *display)
 				syslog(LOG_ERR, "%s: unable to get idle time", display);
 				return(-1);
 			}
-		}
-		else {
+		} else {
 			syslog(LOG_ERR, "%s: Xidle extension not loaded", display);
 			return(-1);
 		}
 		XCloseDisplay(dpy);
-	}
-	else {
+	} else {
 		syslog(LOG_ERR, "%s: server grabbed for over 10 seconds", display);
 		return(-1);
 	}
@@ -134,10 +104,10 @@ XqueryIdle(char *display)
 #endif
 
 static u_int
-getidle(char *tty, char *display)
+getidle(const char *tty, const char *display __unused)
 {
 	struct stat st;
-	char devname[PATH_MAX];
+	char ttyname[PATH_MAX];
 	time_t now;
 	u_long idle;
 
@@ -159,115 +129,87 @@ getidle(char *tty, char *display)
 #endif
 		mouse_idle = getidle("mouse", NULL);
 		idle = (kbd_idle < mouse_idle)?kbd_idle:mouse_idle;
-	}
-	else {
-		sprintf(devname, "%s/%s", _PATH_DEV, tty);
-		if (stat(devname, &st) < 0) {
+	} else {
+		sprintf(ttyname, "%s/%s", _PATH_DEV, tty);
+		if (stat(ttyname, &st) < 0) {
 #ifdef DEBUG
-			printf("%s: %s\n", devname, strerror(errno));
+			printf("%s: %s\n", ttyname, strerror(errno));
 #endif
 			return(-1);
 		}
 		time(&now);
 #ifdef DEBUG
-		printf("%s: now=%d atime=%d\n", devname, now,
+		printf("%s: now=%d atime=%d\n", ttyname, now,
 		       st.st_atime);
 #endif
 		idle = now - st.st_atime;
 		idle = (idle + 30) / 60; /* secs->mins */
 	}
-	if (idle < 0) idle = 0;
 
 	return(idle);
 }
 
 static utmpidlearr *
-do_names_2(int all)
+do_names_2(void)
 {
 	static utmpidlearr ut;
-	struct utmp usr;
+	struct utmpx *usr;
 	int nusers = 0;
 
-	bzero((char *)&ut, sizeof(ut));
+	memset(&ut, 0, sizeof(ut));
 	ut.utmpidlearr_val = &utmp_idle[0];
 
-	ufp = fopen(_PATH_UTMP, "r");
-	if (!ufp) {
-		syslog(LOG_ERR, "%m");
-		return(&ut);
+	setutxent();
+	while ((usr = getutxent()) != NULL && nusers < MAXUSERS) {
+		if (usr->ut_type != USER_PROCESS)
+			continue;
+
+		memcpy(&utmp_list[nusers], usr, sizeof(*usr));
+		utmp_idle[nusers].ui_utmp.ut_time = usr->ut_tv.tv_sec;
+		utmp_idle[nusers].ui_idle =
+		    getidle(usr->ut_line, usr->ut_host);
+		utmp_idle[nusers].ui_utmp.ut_line =
+		    utmp_list[nusers].ut_line;
+		utmp_idle[nusers].ui_utmp.ut_name =
+		    utmp_list[nusers].ut_user;
+		utmp_idle[nusers].ui_utmp.ut_host =
+		    utmp_list[nusers].ut_host;
+
+		nusers++;
 	}
-
-	/* only entries with both name and line fields */
-	while (fread((char *)&usr, sizeof(usr), 1, ufp) == 1 &&
-	       nusers < MAXUSERS)
-		if (*usr.ut_name && *usr.ut_line &&
-		    strncmp(usr.ut_name, IGNOREUSER,
-			    sizeof(usr.ut_name))
-#ifdef OSF
-		    && usr.ut_type == USER_PROCESS
-#endif
-		    ) {
-			utmp_idle[nusers].ui_utmp.ut_time =
-				usr.ut_time;
-			utmp_idle[nusers].ui_idle =
-				getidle(usr.ut_line, usr.ut_host);
-			utmp_idle[nusers].ui_utmp.ut_line = line[nusers];
-			strncpy(line[nusers], usr.ut_line, UT_LINESIZE);
-			utmp_idle[nusers].ui_utmp.ut_name = name[nusers];
-			strncpy(name[nusers], usr.ut_name, UT_NAMESIZE);
-			utmp_idle[nusers].ui_utmp.ut_host = host[nusers];
-			strncpy(host[nusers], usr.ut_host, UT_HOSTSIZE);
-
-			/* Make sure entries are NUL terminated */
-			line[nusers][UT_LINESIZE] =
-			name[nusers][UT_NAMESIZE] =
-			host[nusers][UT_HOSTSIZE] = '\0';
-			nusers++;
-		}
+	endutxent();
 
 	ut.utmpidlearr_len = nusers;
-	fclose(ufp);
 	return(&ut);
 }
 
-int *
-rusers_num(void)
+static int *
+rusers_num(void *argp __unused, struct svc_req *rqstp __unused)
 {
 	static int num_users = 0;
-	struct utmp usr;
-
-	ufp = fopen(_PATH_UTMP, "r");
-	if (!ufp) {
-		syslog(LOG_ERR, "%m");
-		return(NULL);
+	struct utmpx *usr;
+ 
+	setutxent();
+	while ((usr = getutxent()) != NULL) {
+		if (usr->ut_type != USER_PROCESS)
+			continue;
+		num_users++;
 	}
-
-	/* only entries with both name and line fields */
-	while (fread((char *)&usr, sizeof(usr), 1, ufp) == 1)
-		if (*usr.ut_name && *usr.ut_line &&
-		    strncmp(usr.ut_name, IGNOREUSER,
-			    sizeof(usr.ut_name))
-#ifdef OSF
-		    && usr.ut_type == USER_PROCESS
-#endif
-		    ) {
-			num_users++;
-		}
-
-	fclose(ufp);
+	endutxent();
+ 
 	return(&num_users);
 }
 
 static utmparr *
-do_names_1(int all)
+do_names_1(void)
 {
 	utmpidlearr *utidle;
 	static utmparr ut;
-	int i;
+	unsigned int i;
 
 	bzero((char *)&ut, sizeof(ut));
 
-	utidle = do_names_2(all);
+	utidle = do_names_2();
 	if (utidle) {
 		ut.utmparr_len = utidle->utmpidlearr_len;
 		ut.utmparr_val = &old_utmp[0];
@@ -281,29 +223,31 @@ do_names_1(int all)
 }
 
 utmpidlearr *
-rusersproc_names_2_svc(void *argp, struct svc_req *rqstp)
+rusersproc_names_2_svc(void *argp __unused, struct svc_req *rqstp __unused)
 {
-	return(do_names_2(0));
+	return (do_names_2());
 }
 
 utmpidlearr *
-rusersproc_allnames_2_svc(void *argp, struct svc_req *rqstp)
+rusersproc_allnames_2_svc(void *argp __unused, struct svc_req *rqstp __unused)
 {
-	return(do_names_2(1));
+	return (do_names_2());
 }
 
 utmparr *
-rusersproc_names_1_svc(void *argp, struct svc_req *rqstp)
+rusersproc_names_1_svc(void *argp __unused, struct svc_req *rqstp __unused)
 {
-	return(do_names_1(0));
+	return (do_names_1());
 }
 
 utmparr *
-rusersproc_allnames_1_svc(void *argp, struct svc_req *rqstp)
+rusersproc_allnames_1_svc(void *argp __unused, struct svc_req *rqstp __unused)
 {
-	return(do_names_1(1));
+	return (do_names_1());
 }
 
+typedef void *(*rusersproc_t)(void *, struct svc_req *);
+
 void
 rusers_service(struct svc_req *rqstp, SVCXPRT *transp)
 {
@@ -311,8 +255,8 @@ rusers_service(struct svc_req *rqstp, SVCXPRT *transp)
 		int fill;
 	} argument;
 	char *result;
-	bool_t (*xdr_argument)(), (*xdr_result)();
-	char *(*local)();
+	xdrproc_t xdr_argument, xdr_result;
+	rusersproc_t local;
 
 	switch (rqstp->rq_proc) {
 	case NULLPROC:
@@ -320,20 +264,20 @@ rusers_service(struct svc_req *rqstp, SVCXPRT *transp)
 		goto leave;
 
 	case RUSERSPROC_NUM:
-		xdr_argument = xdr_void;
-		xdr_result = xdr_int;
-		local = (char *(*)()) rusers_num;
+		xdr_argument = (xdrproc_t)xdr_void;
+		xdr_result = (xdrproc_t)xdr_int;
+		local = (rusersproc_t)rusers_num;
 		break;
 
 	case RUSERSPROC_NAMES:
-		xdr_argument = xdr_void;
-		xdr_result = xdr_utmpidlearr;
+		xdr_argument = (xdrproc_t)xdr_void;
+		xdr_result = (xdrproc_t)xdr_utmpidlearr;
 		switch (rqstp->rq_vers) {
 		case RUSERSVERS_ORIG:
-			local = (char *(*)()) rusersproc_names_1_svc;
+			local = (rusersproc_t)rusersproc_names_1_svc;
 			break;
 		case RUSERSVERS_IDLE:
-			local = (char *(*)()) rusersproc_names_2_svc;
+			local = (rusersproc_t)rusersproc_names_2_svc;
 			break;
 		default:
 			svcerr_progvers(transp, RUSERSVERS_ORIG, RUSERSVERS_IDLE);
@@ -343,14 +287,14 @@ rusers_service(struct svc_req *rqstp, SVCXPRT *transp)
 		break;
 
 	case RUSERSPROC_ALLNAMES:
-		xdr_argument = xdr_void;
-		xdr_result = xdr_utmpidlearr;
+		xdr_argument = (xdrproc_t)xdr_void;
+		xdr_result = (xdrproc_t)xdr_utmpidlearr;
 		switch (rqstp->rq_vers) {
 		case RUSERSVERS_ORIG:
-			local = (char *(*)()) rusersproc_allnames_1_svc;
+			local = (rusersproc_t)rusersproc_allnames_1_svc;
 			break;
 		case RUSERSVERS_IDLE:
-			local = (char *(*)()) rusersproc_allnames_2_svc;
+			local = (rusersproc_t)rusersproc_allnames_2_svc;
 			break;
 		default:
 			svcerr_progvers(transp, RUSERSVERS_ORIG, RUSERSVERS_IDLE);
@@ -363,8 +307,8 @@ rusers_service(struct svc_req *rqstp, SVCXPRT *transp)
 		svcerr_noproc(transp);
 		goto leave;
 	}
-	bzero((char *)&argument, sizeof(argument));
-	if (!svc_getargs(transp, (xdrproc_t)xdr_argument, (caddr_t)&argument)) {
+	bzero(&argument, sizeof(argument));
+	if (!svc_getargs(transp, (xdrproc_t)xdr_argument, &argument)) {
 		svcerr_decode(transp);
 		goto leave;
 	}
@@ -373,7 +317,7 @@ rusers_service(struct svc_req *rqstp, SVCXPRT *transp)
 	    !svc_sendreply(transp, (xdrproc_t)xdr_result, result)) {
 		svcerr_systemerr(transp);
 	}
-	if (!svc_freeargs(transp, (xdrproc_t)xdr_argument, (caddr_t)&argument)) {
+	if (!svc_freeargs(transp, (xdrproc_t)xdr_argument, &argument)) {
 		syslog(LOG_ERR, "unable to free arguments");
 		exit(1);
 	}
diff --git a/libexec/rpc.rusersd/rusersd.c b/libexec/rpc.rusersd/rusersd.c
index 14a6c3a3e4..ad5d3d7d8e 100644
--- a/libexec/rpc.rusersd/rusersd.c
+++ b/libexec/rpc.rusersd/rusersd.c
@@ -1,4 +1,6 @@
 /*-
+ * SPDX-License-Identifier: BSD-3-Clause
+ *
  * Copyright (c) 1993, John Brezak
  * All rights reserved.
  *
@@ -26,7 +28,7 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- * $FreeBSD: src/libexec/rpc.rusersd/rusersd.c,v 1.8 1999/08/28 00:09:56 peter Exp $
+ * $FreeBSD: head/libexec/rpc.rusersd/rusersd.c 326025 2017-11-20 19:49:47Z pfg $
  */
 
 #include <stdlib.h>
@@ -34,16 +36,14 @@
 #include <sys/socket.h>
 #include <signal.h>
 #include <syslog.h>
-#define utmp rutmp
 #include <rpcsvc/rnusers.h>
-#undef utmp
 
-extern void rusers_service();
+#include "extern.h"
 
 int from_inetd = 1;
 
-void __dead2
-cleanup(int sig)
+static void __dead2
+cleanup(int sig __unused)
 {
 	(void) rpcb_unset(RUSERSPROG, RUSERSVERS_IDLE, NULL);
 	(void) rpcb_unset(RUSERSPROG, RUSERSVERS_ORIG, NULL);
@@ -51,12 +51,12 @@ cleanup(int sig)
 }
 
 int
-main(int argc, char *argv[])
+main(int argc __unused, char *argv[] __unused)
 {
-	SVCXPRT *transp;
+	SVCXPRT *transp = NULL; /* Keep compiler happy. */
 	int ok;
 	struct sockaddr_storage from;
-	int fromlen;
+	socklen_t fromlen;
 
 	/*
 	 * See if inetd started us
@@ -69,8 +69,8 @@ main(int argc, char *argv[])
 	if (!from_inetd) {
 		daemon(0, 0);
 
-		(void) pmap_unset(RUSERSPROG, RUSERSVERS_IDLE);
-		(void) pmap_unset(RUSERSPROG, RUSERSVERS_ORIG);
+		(void) rpcb_unset(RUSERSPROG, RUSERSVERS_IDLE, NULL);
+		(void) rpcb_unset(RUSERSPROG, RUSERSVERS_ORIG, NULL);
 
 		(void) signal(SIGINT, cleanup);
 		(void) signal(SIGTERM, cleanup);
@@ -86,25 +86,25 @@ main(int argc, char *argv[])
 			exit(1);
 		}
 		ok = svc_reg(transp, RUSERSPROG, RUSERSVERS_IDLE,
-		    rusers_service, NULL);
+			     rusers_service, NULL);
 	} else
 		ok = svc_create(rusers_service,
-		    RUSERSPROG, RUSERSVERS_IDLE, "udp");
+				RUSERSPROG, RUSERSVERS_IDLE, "udp");
 	if (!ok) {
 		syslog(LOG_ERR, "unable to register (RUSERSPROG, RUSERSVERS_IDLE, %s)", (!from_inetd)?"udp":"(inetd)");
 		exit(1);
 	}
-
 	if (from_inetd)
 		ok = svc_reg(transp, RUSERSPROG, RUSERSVERS_ORIG,
-		    rusers_service, NULL);
+			     rusers_service, NULL);
 	else
 		ok = svc_create(rusers_service,
-		    RUSERSPROG, RUSERSVERS_ORIG, "udp");
+				RUSERSPROG, RUSERSVERS_ORIG, "udp");
 	if (!ok) {
 		syslog(LOG_ERR, "unable to register (RUSERSPROG, RUSERSVERS_ORIG, %s)", (!from_inetd)?"udp":"(inetd)");
 		exit(1);
 	}
+
 	svc_run();
 	syslog(LOG_ERR, "svc_run returned");
 	exit(1);
diff --git a/libexec/talkd/Makefile b/libexec/talkd/Makefile
index 501d1d31f7..91b8a1ea79 100644
--- a/libexec/talkd/Makefile
+++ b/libexec/talkd/Makefile
@@ -11,6 +11,6 @@ DPADD=	${LIBUTIL}
 LDADD=	-lutil
 
 CFLAGS+=-I${.CURDIR}/../../usr.bin/wall
-CFLAGS+=-I${.CURDIR}/../../usr.bin/who -DSUPPORT_UTMP -DSUPPORT_UTMPX
+CFLAGS+=-I${.CURDIR}/../../usr.bin/who
 
 .include <bsd.prog.mk>
diff --git a/libexec/telnetd/Makefile b/libexec/telnetd/Makefile
index 6ed20a6259..5c1c0cdc99 100644
--- a/libexec/telnetd/Makefile
+++ b/libexec/telnetd/Makefile
@@ -11,8 +11,7 @@ SRCS=		authenc.c global.c slc.c state.c sys_term.c telnetd.c \
 
 WARNS?=		2
 
-CFLAGS+=	-DLINEMODE -DUSE_TERMIO -DDIAGNOSTICS
-CFLAGS+=	-DOLD_ENVIRON -DENV_HACK -DSUPPORT_UTMP -DSUPPORT_UTMPX
+CFLAGS+=	-DLINEMODE -DUSE_TERMIO -DDIAGNOSTICS -DOLD_ENVIRON -DENV_HACK
 CFLAGS+=	-I${.CURDIR}/../../lib
 
 .if !defined(NO_INET6)
diff --git a/libexec/telnetd/sys_term.c b/libexec/telnetd/sys_term.c
index 71dac32fec..ae20362402 100644
--- a/libexec/telnetd/sys_term.c
+++ b/libexec/telnetd/sys_term.c
@@ -34,9 +34,7 @@
 #include <sys/tty.h>
 #include <libutil.h>
 #include <stdlib.h>
-#ifdef SUPPORT_UTMPX
 #include <utmpx.h>
-#endif
 
 #include "telnetd.h"
 #include "pathnames.h"
@@ -1323,14 +1321,8 @@ cleanup(int sig __unused)
 	 */
 	sigfillset(&mask);
 	sigprocmask(SIG_SETMASK, &mask, NULL);
-#ifdef SUPPORT_UTMP
-	if (logout(p))
-		logwtmp(p, "", "");
-#endif
-#ifdef SUPPORT_UTMPX
 	if (logoutx(p, 0, DEAD_PROCESS))
 		logwtmpx(p, "", "", 0, DEAD_PROCESS);
-#endif
 	(void)chmod(line, 0666);
 	(void)chown(line, 0, 0);
 	*p = 'p';
diff --git a/libexec/telnetd/telnetd.c b/libexec/telnetd/telnetd.c
index 44cf1a1385..5c2f1856bb 100644
--- a/libexec/telnetd/telnetd.c
+++ b/libexec/telnetd/telnetd.c
@@ -38,9 +38,6 @@
 #include <libutil.h>
 #include <paths.h>
 #include <termcap.h>
-#ifdef SUPPORT_UTMP
-#include <utmp.h>
-#endif
 
 #include <arpa/inet.h>
 
@@ -54,9 +51,6 @@ int	auth_level = 0;
 #include <libtelnet/misc.h>
 
 char	remote_hostname[MAXHOSTNAMELEN];
-#ifdef SUPPORT_UTMP
-size_t	utmp_len = sizeof(remote_hostname) - 1;
-#endif
 int	registerd_host_only = 0;
 
 
@@ -271,13 +265,7 @@ main(int argc, char *argv[])
 			break;
 
 		case 'u':
-#ifdef SUPPORT_UTMP
-			utmp_len = (size_t)atoi(optarg);
-			if (utmp_len >= sizeof(remote_hostname))
-				utmp_len = sizeof(remote_hostname) - 1;
-#else
 			fprintf(stderr, "telnetd: -u option unneeded\n");
-#endif
 			break;
 
 		case 'U':
@@ -641,9 +629,6 @@ terminaltypeok(char *s)
 void
 doit(struct sockaddr *who)
 {
-#ifdef SUPPORT_UTMP
-	int err_; /* XXX */
-#endif
 	int ptynum;
 
 	/*
@@ -675,15 +660,6 @@ doit(struct sockaddr *who)
 	Please contact your net administrator");
 	remote_hostname[sizeof(remote_hostname) - 1] = '\0';
 
-#ifdef SUPPORT_UTMP
-	trimdomain(remote_hostname, UT_HOSTSIZE);
-	if (!isdigit(remote_hostname[0]) && strlen(remote_hostname) > utmp_len)
-		err_ = getnameinfo(who, who->sa_len, remote_hostname,
-				  sizeof(remote_hostname), NULL, 0,
-				  NI_NUMERICHOST|NI_WITHSCOPEID);
-		/* XXX: do 'err_' check */
-#endif
-
 	(void) gethostname(host_name, sizeof(host_name) - 1);
 	host_name[sizeof(host_name) - 1] = '\0';
 	hostname = host_name;
diff --git a/sbin/init/Makefile b/sbin/init/Makefile
index bfc244fa29..279397b4ed 100644
--- a/sbin/init/Makefile
+++ b/sbin/init/Makefile
@@ -10,7 +10,6 @@ INSTALLFLAGS= -b -B.bak
 INSTALLFLAGS+= -fschg
 .endif
 CFLAGS+=-DDEBUGSHELL -DSECURE -DLOGIN_CAP -DCOMPAT_SYSV_INIT
-CFLAGS+=-DSUPPORT_UTMP -DSUPPORT_UTMPX
 DPADD=	${LIBUTIL} ${LIBCRYPT} ${LIBCRYPTO}
 LDADD=	-lutil -lcrypt -lprivate_crypto
 LDFLAGS+=	${PRIVATELIB_LDFLAGS}
diff --git a/sbin/init/init.c b/sbin/init/init.c
index 79b85346a2..e8f84d9d9d 100644
--- a/sbin/init/init.c
+++ b/sbin/init/init.c
@@ -196,7 +196,6 @@ static void	add_session(session_t *);
 static void	del_session(session_t *);
 static session_t *find_session(pid_t);
 
-#ifdef SUPPORT_UTMPX
 static struct timeval boot_time;
 state_t current_state = death;
 static void session_utmpx(const session_t *, int);
@@ -204,7 +203,6 @@ static void make_utmpx(const char *, const char *, int, pid_t,
     const struct timeval *, int);
 static char get_runlevel(const state_t);
 static void utmpx_set_runlevel(char, char);
-#endif
 
 static int Reboot = FALSE;
 static int howto = RB_AUTOBOOT;
@@ -225,9 +223,7 @@ main(int argc, char *argv[])
 	sigset_t mask;
 	struct stat sts;
 
-#ifdef SUPPORT_UTMPX
 	(void)gettimeofday(&boot_time, NULL);
-#endif /* SUPPORT_UTMPX */
 
 	/* Dispose of random users. */
 	if (getuid() != 0)
@@ -595,11 +591,9 @@ static void
 transition(state_t s)
 {
 	for (;;) {
-#ifdef SUPPORT_UTMPX
 		utmpx_set_runlevel(get_runlevel(current_state),
 		    get_runlevel(s));
 		current_state = s;
-#endif
 		s = (*state_funcs[s])();
 	}
 }
@@ -612,14 +606,8 @@ clear_session_logs(session_t *sp, int status)
 {
 	char *line = sp->se_device + sizeof(_PATH_DEV) - 1;
 
-#ifdef SUPPORT_UTMPX
 	if (logoutx(line, status, DEAD_PROCESS))
 		 logwtmpx(line, "", "", status, DEAD_PROCESS);
-#endif
-#ifdef SUPPORT_UTMP
-	if (logout(line))
-		logwtmp(line, "", "");
-#endif
 }
 
 /*
@@ -880,12 +868,7 @@ f_runcom(void)
 		return single_user;
 
 	runcom_mode = AUTOBOOT;		/* the default */
-#ifdef SUPPORT_UTMPX
 	logwtmpx("~", "reboot", "", 0, INIT_PROCESS);
-#endif
-#ifdef SUPPORT_UTMP
-	logwtmp("~", "reboot", "");
-#endif
 	return read_ttys;
 }
 
@@ -923,9 +906,7 @@ add_session(session_t *sp)
 
 	if ((*session_db->put)(session_db, &key, &data, 0))
 		emergency("insert %d: %s", sp->se_process, strerror(errno));
-#ifdef SUPPORT_UTMPX
 	session_utmpx(sp, 1);
-#endif
 }
 
 /*
@@ -941,9 +922,7 @@ del_session(session_t *sp)
 
 	if ((*session_db->del)(session_db, &key, 0))
 		emergency("delete %d: %s", sp->se_process, strerror(errno));
-#ifdef SUPPORT_UTMPX
 	session_utmpx(sp, 0);
-#endif
 }
 
 /*
@@ -1145,7 +1124,6 @@ f_read_ttys(void)
 	session_t *sp, *snext;
 	struct ttyent *typ;
 
-#ifdef SUPPORT_UTMPX
 	if (sessions == NULL) {
 		struct stat st;
 
@@ -1163,7 +1141,6 @@ f_read_ttys(void)
 			make_utmpx("", DOWN_MSG, DOWN_TIME, 0, &down_time, 0);
 		}
 	}
-#endif
 	/*
 	 * Destroy any previous session state.
 	 * There shouldn't be any, but just in case...
@@ -1549,12 +1526,7 @@ f_death(void)
 	int status;
 	static const int death_sigs[2] = { SIGTERM, SIGKILL };
 
-#ifdef SUPPORT_UTMPX
 	logwtmpx("~", "shutdown", "", 0, INIT_PROCESS);
-#endif
-#ifdef SUPPORT_UTMP
-	logwtmp("~", "shutdown", "");
-#endif
 
 	for (sp = sessions; sp; sp = sp->se_next) {
 		sp->se_flags |= SE_SHUTDOWN;
@@ -1779,7 +1751,6 @@ setprocresources(const char *cname)
 }
 #endif
 
-#ifdef SUPPORT_UTMPX
 static void
 session_utmpx(const session_t *sp, int add)
 {
@@ -1860,4 +1831,3 @@ utmpx_set_runlevel(char old, char new)
 		warning("can't add utmpx record for `runlevel': %m");
 	endutxent();
 }
-#endif
diff --git a/sbin/reboot/Makefile b/sbin/reboot/Makefile
index 30aa22917f..0a996d2ee9 100644
--- a/sbin/reboot/Makefile
+++ b/sbin/reboot/Makefile
@@ -4,7 +4,6 @@
 PROG=	reboot
 DPADD=	${LIBUTIL}
 LDADD=	-lutil
-CFLAGS+=-DSUPPORT_UTMP -DSUPPORT_UTMPX
 MAN=	reboot.8
 MLINKS=	reboot.8 halt.8 reboot.8 fastboot.8 reboot.8 fasthalt.8
 
diff --git a/sbin/reboot/reboot.c b/sbin/reboot/reboot.c
index 0d631d0878..e86ff28dfa 100644
--- a/sbin/reboot/reboot.c
+++ b/sbin/reboot/reboot.c
@@ -45,9 +45,7 @@
 #include <stdlib.h>
 #include <string.h>
 #include <unistd.h>
-#ifdef SUPPORT_UTMPX
 #include <utmpx.h>
-#endif
 
 void usage(void) __dead2;
 u_int get_pageins(void);
@@ -134,12 +132,7 @@ main(int argc, char *argv[])
 			syslog(LOG_CRIT, "rebooted by %s", user);
 		}
 	}
-#ifdef SUPPORT_UTMP
-	logwtmp("~", "shutdown", "");
-#endif
-#ifdef SUPPORT_UTMPX
 	logwtmpx("~", "shutdown", "", 0, INIT_PROCESS);
-#endif
 
 	/*
 	 * Do a sync early on, so disks start transfers while we're off
diff --git a/share/man/man5/Makefile b/share/man/man5/Makefile
index 845396976d..9f3fa80215 100644
--- a/share/man/man5/Makefile
+++ b/share/man/man5/Makefile
@@ -54,7 +54,6 @@ MAN=	acct.5 \
 	sysctl.conf.5 \
 	tmpfs.5 \
 	autofs.5 \
-	utmp.5 \
 	utmpx.5 \
 	uuids.5 \
 	varsym.conf.5
@@ -72,8 +71,6 @@ MLINKS+=null.5 nullfs.5
 MLINKS+=hosts.equiv.5 rhosts.5
 MLINKS+=passwd.5 master.passwd.5
 MLINKS+=resolver.5 resolv.conf.5
-MLINKS+=utmp.5 lastlog.5 \
-	utmp.5 wtmp.5
 MLINKS+=utmpx.5 lastlogx.5 \
 	utmpx.5 wtmpx.5
 
